#include "NWG.h"

/* NGからの戻り値 */
/* 検索 */
const unsigned char NG_find[]={ 0x00,0x01,0x00,0x00, 0x81,0x01,0x00,0x28 };
/* NG接続検出 */
const unsigned char NG_s1c[]={ 0x00,0x01,0x00,0x00, 0x81,0x64,0x01,0x64 };	// modified R1.1
const unsigned char NG_s2c[]={ 0x00,0x01,0x00,0x00, 0x81,0x65,0x01,0x64 };	// modified R1.1

unsigned long	gethostaddr2(void)
{
struct  sockaddr_in addr;
int  sock, size;

  memset((char *)&addr, 0, sizeof(addr));
  addr.sin_family = AF_INET;
  addr.sin_addr.s_addr = INADDR_ANY;
  addr.sin_port = 0;
  if ((sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
    return 0xffffffff;
  };
  if (bind(sock, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
    closesocket(sock);
    return 0xfffffffe;
  };
  size = sizeof(addr);
  if ((getsockname(sock, (struct sockaddr *)&addr, &size)) < 0) {
    closesocket(sock);
    return 0xfffffffd;
  };
  closesocket(sock);
  if (addr.sin_addr.s_addr == INADDR_ANY) {
    return INADDR_LOOPBACK;
  };
  return addr.sin_addr.s_addr;
}

TNWG::TNWG(BLooper *Target , BMessage *Message , const char *NWGAdr)
{
struct in_addr addr;
char *MYIP;

  NWGAddress.SetTo(NWGAdr,4449);

  NWGEndpoint.SetProtocol(SOCK_DGRAM);
  NWGEndpoint.SetNonBlocking(false);
  NWGEndpoint.SetTimeout(100000);

  addr.s_addr = gethostaddr2();
  MYIP = inet_ntoa(addr);
  LocalAddress.SetTo(MYIP,1026);
  NWGEndpoint.Bind(1026);

  NWG_S1C_P[0] = 0x00010000;//0x00000100;
  NWG_S1C_P[1] = 0x016a0004;//0x04006a01;
  NWG_S1C_P[2] = 0x00000000;//0x00000000;
  NWG_S1C_P[3] = 0x00000000;//0x00000000;
  NWG_S1C_P[4] = inet_addr( NWGAdr );

  NWG_S2C_P[0] = 0x00010000;//0x00000100;
  NWG_S2C_P[1] = 0x016b0004;//0x04006b01;
  NWG_S2C_P[2] = 0x00000000;//0x00000000;
  NWG_S2C_P[3] = 0x00000000;//0x00000000;
  NWG_S2C_P[4] = inet_addr( NWGAdr );

  NWG_S1D_P[0] = 0x00010000;//0x00000100;
  NWG_S1D_P[1] = 0x01680004;//0x04006801;
  NWG_S1D_P[2] = 0x00000000;//0x00000000;
  NWG_S1D_P[3] = 0x00000000;//0x00000000;
  NWG_S1D_P[4] = inet_addr( NWGAdr );

  NWG_S2D_P[0] = 0x00010000;//0x00000100;
  NWG_S2D_P[1] = 0x01690004;//0x04006901;
  NWG_S2D_P[2] = 0x00000000;//0x00000000;
  NWG_S2D_P[3] = 0x00000000;//0x00000000;
  NWG_S2D_P[4] = inet_addr( NWGAdr );

  NWG_S1_C[0] = 0x00010000;//0x00000100;
  NWG_S1_C[1] = 0x01640008;//0x08006401;
  NWG_S1_C[2] = 0x00000000;//0x00000000;
  NWG_S1_C[3] = 0x00000000;//0x00000000;
  NWG_S1_C[4] = inet_addr( NWGAdr );
  NWG_S1_C[5] = 0x0000ff00;//0x00ff0000;		// added R1.1

  NWG_S2_C[0] = 0x00010000;//0x00000100;
  NWG_S2_C[1] = 0x01650008;//0x08006501;
  NWG_S2_C[2] = 0x00000000;//0x00000000;
  NWG_S2_C[3] = 0x00000000;//0x00000000;
  NWG_S2_C[4] = inet_addr( NWGAdr );
  NWG_S2_C[5] = 0x00000000;//0x00000000;		// added R1.1

  NWGLooper = new TNWGLooper(Target,Message,&NWGEndpoint,&NWGAddress);
}

TNWG::~TNWG()
{
  NWGLooper->loop = false;
  NWGLooper->Lock();
  NWGLooper->Quit();
  NWGEndpoint.Close();
}

int TNWG::Serial1Connect()
{
  return NWGEndpoint.SendTo(NWG_S1C_P,20,NWGAddress,0);
}

int TNWG::Serial1DisConnect()
{
  return NWGEndpoint.SendTo(NWG_S1D_P,20,NWGAddress,0);
}

int TNWG::Serial2Connect()
{
  return NWGEndpoint.SendTo(NWG_S2C_P,20,NWGAddress,0);
}

int TNWG::Serial2DisConnect()
{
  return NWGEndpoint.SendTo(NWG_S2D_P,20,NWGAddress,0);
}

int TNWG::Serial1Check()
{
  return NWGEndpoint.SendTo(NWG_S1_C,24,NWGAddress,0);	// modified R1.1
}

int TNWG::Serial2Check()
{
  return NWGEndpoint.SendTo(NWG_S2_C,24,NWGAddress,0);	// modified R1.1
}

TNWGLooper::TNWGLooper(BLooper *Target , BMessage *Message , BNetEndpoint *NWGEp, BNetAddress *NWGAdrs):BLooper("NWGLooper")
{
BMessage StartMsg('stat');

  NWGEndpoint = NWGEp;
  NWGAddress = NWGAdrs;
  if ( Target == NULL ) {
    MessageTarget = be_app;
  } else {
    MessageTarget = Target;
  };
  InfoMessage = Message;
  InfoMessage->AddInt32("status",NWG_OK);

  this->Run();
  this->PostMessage(&StartMsg);
}

TNWGLooper::~TNWGLooper()
{
  delete InfoMessage;
}

void TNWGLooper::MessageReceived( BMessage *msg )
{
  switch( msg->what ) {
    case 'stat':
      Receiving();
      break;
  };
}

void TNWGLooper::Receiving()
{
unsigned char buf[1500];
int loglen,i,s1,s2,find;

  loop = true;
  while ( loop==true ) {
    s1 = 0;
    s2 = 0;
    find = 0;
    loglen = NWGEndpoint->ReceiveFrom(buf,1500,*NWGAddress,0);
    if ( loglen > 0 ) {
      for (i=0;i<7;i++) {
        if ( buf[i] == NG_find[i] ) { find++; };
        if ( buf[i] == NG_s1c[i] ) { s1++; };
        if ( buf[i] == NG_s2c[i] ) { s2++; };
      };

/*  NWG 発見?(まだ開発中です)  */
      if ( find == 7 ) {
      };

/*  Serial1 接続?  */
      if ( s1 == 7 ) {
        if ( buf[35] == 0x05 ) {	// modified R1.1
          InfoMessage->ReplaceInt32("status",NWG_SERIAL1_CONNECTED);
          MessageTarget->PostMessage(InfoMessage);
        };
        if ( buf[35] == 0x03 ) {	// modified R1.1
          InfoMessage->ReplaceInt32("status",NWG_SERIAL1_DISCONNECTED);
          MessageTarget->PostMessage(InfoMessage);
        };
      };

/*  Serial2 接続?  */
      if ( s2 == 7 ) {
        if ( buf[35] == 0x05 ) {	// modified R1.1
          InfoMessage->ReplaceInt32("status",NWG_SERIAL2_CONNECTED);
          MessageTarget->PostMessage(InfoMessage);
        };
        if ( buf[35] == 0x03 ) {	// modified R1.1
          InfoMessage->ReplaceInt32("status",NWG_SERIAL2_DISCONNECTED);
          MessageTarget->PostMessage(InfoMessage);
        };
      };
    };
  };
}
