#include "NWGWindow.h"
#include <stdio.h>

/* デフォルトのIPアドレスを変更したい場合はここを変更してMakeしてください */
const char *NGIP = "192.168.0.1";

TNWGWindow::TNWGWindow( BRect frame ):BWindow( frame, "BeNG", B_TITLED_WINDOW,B_NOT_RESIZABLE | B_NOT_ZOOMABLE | B_PULSE_NEEDED)
{
BRect viewFrame = Bounds();
char title[256];

  NWG = new TNWG( this, new BMessage(NWG_INFO_MSG), NGIP );
  view = new TNWGView( viewFrame, this);
  AddChild( view );
  sprintf(title,"BeNG@%s",NGIP);
  SetTitle(title);
  SetPulseRate(1500000);

  NWG->Serial1Check();
  NWG->Serial2Check();
}

bool TNWGWindow::QuitRequested()
{
  delete NWG;
  be_app->PostMessage( B_QUIT_REQUESTED );
  return true;
}

void TNWGWindow::MessageReceived( BMessage* msg )
{
int32 status;

switch( msg->what )
{
  case 'puls':
    NWG->Serial1Check();
    NWG->Serial2Check();
    break;
  case S1C_PRESSED:
    NWG->Serial1Connect();
    break;
  case S2C_PRESSED:
    NWG->Serial2Connect();
    break;
  case S1D_PRESSED:
    NWG->Serial1DisConnect();
    break;
  case S2D_PRESSED:
    NWG->Serial2DisConnect();
    break;
  case NWG_INFO_MSG:
    if ( msg->FindInt32("status",0,&status) != B_OK ) {
      break;
    };
    if ( status == NWG_SERIAL1_CONNECTED ) {
      view->S1Connect_btn->SetEnabled(false);
      view->S1DisConnect_btn->SetEnabled(true);
    };
    if ( status == NWG_SERIAL1_DISCONNECTED ) {
      view->S1Connect_btn->SetEnabled(true);
      view->S1DisConnect_btn->SetEnabled(false);
    };
    if ( status == NWG_SERIAL2_CONNECTED ) {
      view->S2Connect_btn->SetEnabled(false);
      view->S2DisConnect_btn->SetEnabled(true);
    };
    if ( status == NWG_SERIAL2_DISCONNECTED ) {
      view->S2Connect_btn->SetEnabled(true);
      view->S2DisConnect_btn->SetEnabled(false);
    };
    break;
  default:
    inherited::MessageReceived( msg );
  }
}
